
package de.ivu.elect.business.wahl.boundary;

import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Event;
import javax.inject.Inject;
import javax.inject.Named;


import de.ivu.elect.business.wahl.entity.Wahltermin;

@RequestScoped
@Named(WahlterminSessionSelect.COMPONENT_NAME)
public class WahlterminSessionSelect implements java.io.Serializable  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlterminSessionSelect";

  @Inject
  protected transient WahlterminExtendedDAO entityDAO;

  @Inject
  protected transient WahlterminSessionStore sessionStore;

  @Inject
  protected transient Event<WahlterminSelectChangeEvent> entitySelectChangeEvent;

  private transient Boolean selectedCache = null;

  public WahlterminSessionSelect() {
    super();
  }

  public boolean isSelected() {
    if (selectedCache == null) { // NPE beim Löschen von Entitäten verhindern
      if (getEntityPK() == null) {
        selectedCache = false;
      } else {
        selectedCache = getEntity() != null;
      }
    }

    return selectedCache;
  }

  public Wahltermin getEntity() {
    return getEntityInternal();
  }

  private Wahltermin getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Wahltermin entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.wahl.entity.WahlterminPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Wahltermin entity) {
    if (entity == null && getEntityPK() != null) {
      changeEntityPkFireEvent(null, null);
    } else if (entity != null && !entity.getPk().equals(getEntityPK())) {
      if (isSetzenErlaubt(entity)){
        changeEntityPkFireEvent(entity, entity.getPk());
      }
    }
  }

  public
    de.ivu.elect.business.wahl.entity.WahlterminPK
   getEntityPK() {
    return sessionStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.wahl.entity.WahlterminPK
   entityPK) {
    selectedCache = null;
    sessionStore.setEntityPK(entityPK);
  }

  protected Wahltermin attach(Wahltermin entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Wahltermin attach( de.ivu.elect.business.wahl.entity.WahlterminPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public boolean isSetzenErlaubt(Wahltermin entity) {
    return true; // Überschreiben, wenn etwas geprüft werden soll...
  }

  private void changeEntityPkFireEvent(Wahltermin neueEntity,
    de.ivu.elect.business.wahl.entity.WahlterminPK
    neueEntityPK) {
    final Wahltermin alteEntity = getEntityInternal();
    setEntityPK(neueEntityPK);
    entitySelectChangeEvent.fire(new WahlterminSelectChangeEvent(alteEntity, neueEntity));
  }
}
